//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "jpeg.hpp"
#include "gifimg.hpp"
#include <pngimage.hpp>
#include <Graphics.hpp>
#include <printers.hpp>
#include <Clipbrd.hpp>
#include "Unit3.h"
#include "help.h"
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
  String FNAM,EXT;
  TBitmap *bmp;
  Graphics::TBitmap *BMP,*BMP0;
  float strech;
  int X,Y;

void rotate(int flg)
{
  int x0,y0,x1,y1,color;

  Screen->Cursor=crAppStart;

  BMP=new Graphics::TBitmap;

  BMP->Assign(Form1->Image1->Picture);

  BMP0=new Graphics::TBitmap;

  if(flg==3)  //E]
   {
	BMP0->Width=BMP->Width;
	BMP0->Height=BMP->Height;
   }
  else
   {
	BMP0->Width=BMP->Height;
	BMP0->Height=BMP->Width;
   }

  switch(flg)
   {
	 case 1:
	  for(x0=0;x0<BMP->Width;x0++)
	   {
		x1=BMP->Height-1;
		for(y0=0;y0<BMP->Height;y0++)
		 {
		  color=BMP->Canvas->Pixels[x0][y0];
		  BMP0->Canvas->Pixels[x1-y0][x0]=color;
		 }
		}
	   break;
	 case 2:
	  for(x0=0;x0<BMP->Width;x0++)
	   {
		x1=BMP->Width-1;
		for(y0=0;y0<BMP->Height;y0++)
		 {
		  color=BMP->Canvas->Pixels[x0][y0];
		  BMP0->Canvas->Pixels[y0][x1-x0]=color;
		 }
	   }
	  break;
	 case 3: //E]
	  x1=BMP->Width-1;
 	  for(x0=0;x0<BMP->Width;x0++)
	   {
		 for(y0=0;y0<BMP->Height;y0++)
		  {
		color=BMP->Canvas->Pixels[x0][y0];
		BMP0->Canvas->Pixels[x1-x0][y0]=color;
		  }
	   }
	  break;

	 default:
	  return;
	}

  bmp->Assign(BMP0);
  Form1->Image1->Picture->Assign(bmp);
  Form1->ScrollBox1->HorzScrollBar->Range=Form1->Image1->Picture->Bitmap->Width;
  Form1->ScrollBox1->VertScrollBar->Range=Form1->Image1->Picture->Bitmap->Height;

  delete BMP,BMP0;

  Screen->Cursor=crArrow;

}

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormActivate(TObject *Sender)
{
 Panel1->Caption="";
 Image1->Align =alClient;
 Image2->Align =alClient;
 ScrollBox1->Align=alClient;
// Button5->Enabled=false;

   strech=1.0;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
   if(CheckBox1->Checked ==true)
   {
	 Image1->Visible=false;

	 Image2->Stretch = true;
	 Image2->Visible=true;

	 ScrollBox1->Enabled=false;
	 ScrollBox1->Visible=false;
	 Image2->Picture->Assign(bmp);

   }
  else
   {
	 Image1->Visible=true;
	 Image2->Visible=false;
	 ScrollBox1->Enabled=true;
	 ScrollBox1->Visible=true;
   }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
 delete bmp;
}
//---------------------------------------------------------------------------
void n3n4enable()
{
  Form1->N3->Enabled=true;
  Form1->N4->Enabled=true;
}
void __fastcall TForm1::N5Click(TObject *Sender)
{
 int flg;
 String ws,hs;

 if(OpenDialog1->Execute())
  {
   Screen->Cursor=crHourGlass;

   CheckBox1->Checked =false;
   Image1->Stretch = false;

   FNAM = OpenDialog1->FileName;

   delete bmp;
   bmp = new Graphics::TBitmap();

   Image2->Visible=false;
   Image2->Stretch = false;
   ScrollBox1->Enabled = true;
   Image1->Visible=true;
   ScrollBox1->Visible=true;
   CheckBox1->Enabled =true;

   EXT = ExtractFileExt(FNAM).UpperCase();

   if(EXT == ".JPG")
	{
	 TJPEGImage *jpg;
	 jpg=new TJPEGImage();

	 jpg->LoadFromFile(FNAM);
	 bmp->Assign(jpg);
	 Image1->Picture->Assign(bmp);
	  delete jpg;
	}
   if(EXT == ".BMP")
	{
	 bmp->LoadFromFile(FNAM);

	 Image1->Picture->Assign(bmp);

	}
   if(EXT == ".TIF")
	{
	 Image2->Center = true;
	 Image2->Visible=true;
	 Image2->Enabled = false;
	 ScrollBox1->Enabled = false;
	 Image1->Visible=false;
	 ScrollBox1->Visible=false;
	 CheckBox1->Enabled =false;

	 Image2->Picture->LoadFromFile(FNAM);
	 flg =255;

	}

   if(EXT == ".PNG")
	{
	 TPngImage *png;
	 png = new TPngImage();

	 png->LoadFromFile(FNAM);
	 bmp->Assign(png);
	 Image1->Picture->Assign(bmp);

	 delete png;
	}

  if(EXT == ".GIF")
	{
	 TGIFImage *gif;
	 gif = new TGIFImage();
	 gif->LoadFromFile(FNAM);

	 bmp->Assign(gif);
	 Image1->Picture->Assign(bmp);
	 delete gif;

	}

  if(EXT == ".ICO")
   {
	 Image2->Center = true;
	 Image2->Visible=true;
	 Image2->Enabled = false;
	 ScrollBox1->Enabled = false;
	 Image1->Visible=false;
	 ScrollBox1->Visible=false;
	 CheckBox1->Enabled =false;

	Image2->Picture->LoadFromFile(FNAM);
	flg=255;

   }
	ScrollBox1->HorzScrollBar->Range=Image1->Picture->Bitmap->Width;
	ScrollBox1->VertScrollBar->Range=Image1->Picture->Bitmap->Height;

	hs="  H"+IntToStr(Image1->Picture->Bitmap->Height);
	ws=" x W"+IntToStr(Image1->Picture->Bitmap->Width);
	X=Image1->Picture->Bitmap->Width;
	Y=Image1->Picture->Bitmap->Height;
	if(flg != 0)
	   Caption = ExtractFileName(OpenDialog1->FileName);
	else
	   Caption = ExtractFileName(OpenDialog1->FileName)+hs+ws;

    n3n4enable();
	Screen->Cursor=crDefault;
  }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::N9Click(TObject *Sender)
{
   String ext,fname;

  if(SaveDialog1->Execute())
   {
	 fname = SaveDialog1->FileName;

	 if(FNAM == fname)
	  {
	   ShowMessage("tACł̂łr`ud܂");
	   return;
	  }

	 ext = ExtractFileExt(fname).UpperCase();
	 if(ext == "")
	  {
		ext=".BMP";
		fname=fname+".bmp";
	  }

	 if(EXT != ext)
	  {
		if((ext != ".JPG") && (ext != ".PNG") &&  (ext != ".GIF")&& (ext != ".BMP"))
		 {
		   ShowMessage(ext+"@̓T||gĂȂ̂łr`udo܂");
		   return;
		 }
		if(ext == ".BMP")
		 {
		  bmp->SaveToFile(fname);
		 }

		if(ext == ".JPG")
		  {
		   TJPEGImage *jpg;
		   jpg =new  TJPEGImage;
		   jpg->Assign(bmp);
		   jpg->SaveToFile(fname);
		   delete jpg;
		  }

		if(ext == ".PNG")
		  {
		   TPngImage *png;
		   png = new TPngImage;
		   png->Assign(bmp);
		   png->SaveToFile(fname);
		   delete png;
		  }
		if(ext == ".GIF")
		  {
			TGIFImage *gif;
			gif = new TGIFImage;
			gif->Assign(bmp);
			gif->SaveToFile(fname);
			delete gif;
		  }
	  }
	 else
	  {
		Image1->Picture->SaveToFile(SaveDialog1->FileName);
	  }

   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N10Click(TObject *Sender)
{
   rotate(1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N11Click(TObject *Sender)
{
  rotate(2);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N12Click(TObject *Sender)
{
   rotate(3);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N4Click(TObject *Sender)
{
  Form3->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N1Click(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::HELP1Click(TObject *Sender)
{
   Form2->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N14Click(TObject *Sender)
{
  int flg;
  String ws,hs;

   delete bmp;
   bmp = new Graphics::TBitmap();


  if(Clipboard()->HasFormat(CF_PICTURE) )
   {
	 bmp->Assign(Clipboard());
	 Image1->Picture->Assign(bmp);


	 Screen->Cursor=crHourGlass;

	  CheckBox1->Checked =false;
	  Image1->Stretch = false;

	  Image2->Visible=false;
	  Image2->Stretch = false;
	  ScrollBox1->Enabled = true;
	  Image1->Visible=true;
	  ScrollBox1->Visible=true;
	  CheckBox1->Enabled =true;


	ScrollBox1->HorzScrollBar->Range=Image1->Picture->Bitmap->Width;
	ScrollBox1->VertScrollBar->Range=Image1->Picture->Bitmap->Height;

	hs="  H"+IntToStr(Image1->Picture->Bitmap->Height);
	ws=" x W"+IntToStr(Image1->Picture->Bitmap->Width);
	Caption = "ClipBoard"+hs+"  "+ws;
	Screen->Cursor=crDefault;

  	X=Image1->Picture->Bitmap->Width;
	Y=Image1->Picture->Bitmap->Height;


   }
  else
   {
	 ShowMessage("Nbv{|hɃf|^܂");
   }

  n3n4enable();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N15Click(TObject *Sender)
{
 Clipboard()->Assign(Image1->Picture);
 ShowMessage("Nbv{|hɕۑ܂");
}
//---------------------------------------------------------------------------
/**
 * }EXzC[𓮂Ƃ̏
 */
void __fastcall TForm1::WMMouseWheel(TMessage &Msg)
{
  TBitmap *sbmp;

  sbmp=new Graphics::TBitmap();
  TRect rect;
  int x,y;
  x=X;
  y=Y;
  rect.Left=0;
  rect.Top=0;

  short int i;

  i=HIWORD( Msg.WParam );
  if(i>0)//zC[Oɓ̏
   {
	 strech=strech+.01;


   }
  else  //zC[ɓ̏
   {
		 strech=strech-.01;
		// if(strech<1) strech=1;
   }
  rect.Bottom =y*strech;
  rect.Right=x*strech;

  sbmp->Width=rect.Right;
  sbmp->Height=rect.Bottom;
  Image1->Picture->Assign(sbmp);

  Image1->Canvas->StretchDraw(rect,bmp);

  delete sbmp;
}









