//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <printers.hpp>

#include "Unit1.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm3 *Form3;
//---------------------------------------------------------------------------
__fastcall TForm3::TForm3(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
extern TBitmap *bmp;

float p,r,r0,r1,dpi,rate,rate_res,res_w,res_h;
TRect rect,p_rect;

int change;
int size_h,size_w,pixel;

void disp()
{
  int w,h,off_w,off_h,H;

  Form3->Image1->Picture = NULL;
  if(change ==0)
   {
	r=(float) Form3->Panel2->Height/(float)bmp->Height;
	r1=  (float) Form3->Panel2->Width/(float)bmp->Width;
	if(r>r1)
	 {
	   rate=r1;
	 }
	else
	 {
	   rate=r;
     }

	 p=20;
	 Form3->ScrollBar1->Position=20;
	}

  else
   {
	 p=Form3->ScrollBar1->Position;
   }

  h=bmp->Height*rate;
  w=bmp->Width*rate;


  if(p<0)
   {
	 r=1/p*-1;
   }
  else
   {
	 r=p/20;

   }

  if(r==0) r=1;

//  off_w=(300-w*r)/2-Form3->Image1->Left-1;
//  off_h=(300*(res_h/res_w)-h*r)/2-Form3->Image1->Top-1;


  off_w=(Form3->Image1->Width-w*r)/2;
  off_h=(Form3->Image1->Height-h*r)/2;

  rect.Top =off_h;
  rect.Left=off_w;

  Form3->Label1->Caption=FloatToStrF(r,ffFixed,15,2);

  r0=(float) res_h/(float)bmp->Height;
  r1=  (float) res_w/(float)bmp->Width;

  if(r0>r1)
   {
	 rate_res=r1;
   }
  else
   {
	 rate_res=r0;
   }

  Form3->Label2->Caption = FloatToStrF((bmp->Width*rate_res*r/pixel),ffFixed,15,0);
  Form3->Label5->Caption = FloatToStrF((bmp->Height*rate_res*r/pixel),ffFixed,15,0);

  rect.Bottom =h*r+off_h;
  rect.Right=w*r+off_w;

  Form3->Image1->Canvas->StretchDraw(rect,bmp);

}
void __fastcall TForm3::Button1Click(TObject *Sender)
{
  int x,y,h,w,off_w,off_h;

  Screen->Cursor=crHourGlass;

  off_w=(res_w-bmp->Width*rate_res*r)/2;
  off_h=(res_h-bmp->Height*rate_res*r)/2;

  p_rect.Top=off_h;
  p_rect.left=off_w;
  p_rect.Right=bmp->Width*rate_res*r+off_w;
  p_rect.Bottom=bmp->Height*rate_res*r+off_h;

  Printer()->BeginDoc();
  Printer()->Canvas->StretchDraw(p_rect,bmp);

  h=(p_rect.Bottom-p_rect.Top)/30;
  w=(p_rect.Right-p_rect.left)/30;

  if(CheckBox1->Checked==true)
   {
	Printer()->Canvas->Pen->Color = clBlack;
	Printer()->Canvas->Pen->Width = 1;
	Printer()->Canvas->Pen->Style = psDash;

	for(x=w+p_rect.left;x<p_rect.Right ;x=x+w)
	 {
	  Printer()->Canvas->MoveTo(x,p_rect.Top);
	  Printer()->Canvas->LineTo(x,p_rect.Bottom);
	 }
	for(y=h+p_rect.Top;y<p_rect.Bottom;y=y+h)
	 {
	  Printer()->Canvas->MoveTo(p_rect.left,y);
	  Printer()->Canvas->LineTo(p_rect.Right,y);
	 }
	}
  Printer()->EndDoc();

  Screen->Cursor=crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TForm3::Button2Click(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void Init()
{
  float w;
  int dpi_x,dpi_y;
  int horzsize,vertsize,i;
  String s;

  Form3->Panel1->Caption="";
  change=0;
  Form3->Image1->Picture = NULL;
  Form3->PrintDialog1->Execute();

  TPrinter *printer=Printer();
  HDC dc=printer->Handle;

  dpi_x=GetDeviceCaps(dc,LOGPIXELSX);

  //  dpi_y=GetDeviceCaps(dc,LOGPIXELSY);

  horzsize=GetDeviceCaps(dc,HORZSIZE);
  vertsize=GetDeviceCaps(dc,VERTSIZE);

  Form3->Memo1->Clear();

  s="LOGPIXELSX       "+IntToStr(dpi_x);
  Form3->Memo1->Lines->Add(s);

//  s="LOGPIXELSY       "+IntToStr(dpi_y);
//  Memo1->Lines->Add(s);


  size_w=GetDeviceCaps(dc,HORZSIZE);
  s="HORZSIZE       "+IntToStr(size_w);
  Form3->Memo1->Lines->Add(s);

  size_h=GetDeviceCaps(dc,VERTSIZE);
  s="VERTSIZE       "+IntToStr(size_h);
  Form3->Memo1->Lines->Add(s);

  res_w=GetDeviceCaps(dc,HORZRES);
  s="HORZRES       "+FloatToStr(res_w);
  Form3->Memo1->Lines->Add(s);

  res_h=GetDeviceCaps(dc,VERTRES);
  s="VERTRES       "+FloatToStr(res_h);
  Form3->Memo1->Lines->Add(s);

  pixel =res_w/size_w;
  rate=300/res_w;

  w=300*(res_h/res_w);
  Form3->Panel2->Height= (int) w;
  Form3->Panel2->Width=300;

  Form3->Image1->Align=alClient;

  Form3->Width=350+Form3->Panel1->Width;
  Form3->Height=500;
 //  Form3->Height=(int)w+70;
  disp();

}
void __fastcall TForm3::FormActivate(TObject *Sender)
{
  Init();
}
//---------------------------------------------------------------------------
void __fastcall TForm3::Button3Click(TObject *Sender)
{
  Init();  //ݒ
}
//---------------------------------------------------------------------------

void __fastcall TForm3::ScrollBar1Change(TObject *Sender)
{
  change=255;
  disp();
}
//---------------------------------------------------------------------------

